<?php

/**
 * 易优CMS
 * ============================================================================
 * 版权所有 2016-2028 海南赞赞网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.eyoucms.com
 * ----------------------------------------------------------------------------
 * 如果商业用途务必到官方购买正版授权, 以免引起不必要的法律纠纷.
 * ============================================================================
 * Author: 小虎哥 <1105415366@qq.com>
 * Date: 2018-06-28
 */

namespace weapp\Lycecho\controller;

use think\Page;
use think\Db;
use app\common\controller\Weapp;


/**
 * 插件的控制器
 */
class Lycecho extends Weapp

{

    /**
     * 实例化对象
     */

    private $db;


    /**
     * 插件基本信息
     */

    private $weappInfo;


    /**
     * 构造方法
     */

    public function __construct()
    {
        parent::__construct();
        $this->db = Db::name('weapp_lycecho');
        /*插件基本信息*/
        $this->weappInfo = $this->getWeappInfo();
        $this->assign('weappInfo', $this->weappInfo);
        /*--end*/
    }

    function getRandStr($length)
    {
        //字符组合
        $str = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $len = strlen($str) - 1;
        $randstr = '';
        for ($i = 0; $i < $length; $i++) {
            $num = mt_rand(0, $len);
            $randstr .= $str[$num];
        }
        return $randstr;
    }


    /**
     * 插件后台管理 - 列表
     */

    public function index()
    {
        $content = $this->db->where("key", "token")->value('content');
        if (!$content) {
            $content = $this->getRandStr(32);
            //初始化一个token
            $this->db->insert(['key' => 'token', 'content' => $content]);
        }
        $this->assign('token', $content);
        return $this->fetch('index');
    }

    function setting()
    {
        $token = input('token');
        if ($token) {
            $has = $this->db->where("key", 'token')->update(['content' => $token]);
            if (!$has) {
                $has = $this->db->insert(['key' => 'token', 'content' => $token]);
            }
        }
        return $this->jsonResp(0, [], '操作成功！');
    }


    function jsonResp($code, $data = [], $msg = '')
    {
        return ['code' => intval($code), 'msg' => $msg, 'data' => $data];
    }

}